 * ---------------------------------------------------------------- ;
 * Control program ;
 * ---------------------------------------------------------------- ;                                

%LET PATH=; *<===USER may modify;

LIBNAME LIBRARY "&PATH";                  *<==USER MUST modify;

*Calendar year;
%LET CAL_YEAR = 2010;    *USER modify ;                        

%LET MCaid_NDX = 9;      *<===USER may modify for the number of diagnosis of medicaid;
%LET MCaid_NPR = 6;      *<===USER may modify for the number of procedure of medicaid;
%LET MCare_NDX = 9;      *<===USER may modify for the number of diagnosis of medicare;
%LET MCare_NPR = 6;      *<===USER may modify for the number of procedure of medicare;
%LET NDX = 9;            *<===USER may modify for the number of diagnosis of medicare/medicaid, the larger number;
%LET NPR = 6;            *<===USER may modify for the number of procedure of medicare/medicare, the larger number;


****************************************************************************
MACRO to create HCBS_IP variable for POPULATION CODE
****************************************************************************;
%MACRO HCBS_IP_POP;
   *remove all discharges that do not occur when someone is enrolled in HCBS.
   Copied from MFP_TASK10_SPEC_19_STEP_1_NONMFP0810.sas, starting on line 49
   Will Drop all records where HCBS_IP is not equal to 1;
   ARRAY USER_FLAGS   (*) HCBS_USER_1 - HCBS_USER_12; 
   ARRAY MAX_FLG      (*) MAX_HCBS_ENROLL_1 - MAX_HCBS_ENROLL_12;
   ARRAY FLAG         (*) HCBS_TIME_FLAG_1 - HCBS_TIME_FLAG_12;

   DO I = 1 TO DIM(USER_FLAGS);
      IF USER_FLAGS(I) = 1 OR MAX_FLG(I) = 1 THEN FLAG(I) = 1;
      ELSE FLAG(I) = 0;
   END;

   DO I=1 TO dim(user_flags) until (user_flags(i) = 1 or max_flg(i)=1);
      IF USER_FLAGS(I) = 1 or max_flg(i)=1 THEN DO;
         FIRST_FLAG=(I);
         FIRST_DATE=MDY((I),01,CALENDAR_YR);
         END_DATE=(INTNX('MONTH',FIRST_DATE,12))-1;
      END;
   END;
   
   IF FIRST_DATE <= ADMIT <= END_DATE THEN USER_FLAG = 1;
   ELSE USER_FLAG = 0;
   IF ADMIT NE . AND USER_FLAG=1 THEN DO;
      IF "01JAN%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31JAN%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_1  = 1 ) THEN HCBS_IP = 1;
      IF "01FEB%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "28FEB%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_2  = 1 ) THEN HCBS_IP = 1;
      IF "01MAR%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31MAR%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_3  = 1 ) THEN HCBS_IP = 1;
      IF "01APR%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30APR%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_4  = 1 ) THEN HCBS_IP = 1;
      IF "01MAY%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31MAY%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_5  = 1 ) THEN HCBS_IP = 1;
      IF "01JUN%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30JUN%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_6  = 1 ) THEN HCBS_IP = 1;
      IF "01JUL%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31JUL%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_7  = 1 ) THEN HCBS_IP = 1;
      IF "01AUG%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31AUG%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_8  = 1 ) THEN HCBS_IP = 1;
      IF "01SEP%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30SEP%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_9  = 1 ) THEN HCBS_IP = 1;
      IF "01OCT%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31OCT%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_10 = 1 ) THEN HCBS_IP = 1;
      IF "01NOV%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30NOV%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_11 = 1 ) THEN HCBS_IP = 1;
      IF "01DEC%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31DEC%EVAL(&CAL_YEAR.+0)"D and (HCBS_TIME_FLAG_12 = 1 ) THEN HCBS_IP = 1;
   END;
   IF HCBS_IP NE 1 THEN HCBS_IP = 0;

%MEND HCBS_IP_POP;

****************************************************************************
MACRO to create MAXDUAL_FLAG variable for POPULATION CODE
****************************************************************************;
%MACRO MAXDUAL_FLAG_POP;
IF FROM='MAX' AND ADMIT NE . THEN DO;
   IF "01JAN%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31JAN%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_1>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01FEB%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "28FEB%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_2>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01MAR%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31MAR%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_3>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01APR%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30APR%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_4>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01MAY%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31MAY%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_5>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01JUN%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30JUN%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_6>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01JUL%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31JUL%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_7>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01AUG%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31AUG%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_8>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01SEP%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30SEP%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_9>'00'  THEN MAXDUAL_FLAG = 1;
   IF "01OCT%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31OCT%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_10>'00' THEN MAXDUAL_FLAG = 1;
   IF "01NOV%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "30NOV%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_11>'00' THEN MAXDUAL_FLAG = 1;
   IF "01DEC%EVAL(&CAL_YEAR.+0)"D <= ADMIT <= "31DEC%EVAL(&CAL_YEAR.+0)"D and EL_MDCR_DUAL_MO_12>'00' THEN MAXDUAL_FLAG = 1;
END;
%MEND MAXDUAL_FLAG_POP;

